$(() => {
const maxDate = new Date();
maxDate.setFullYear(maxDate.getFullYear() - 21);
const sendRequest = function (value) {
const invalidEmail = 'test@dx-email.com';
const d = $.Deferred();
setTimeout(() => {
d.resolve(value !== invalidEmail);
}, 1000);
return d.promise();
};
const changePasswordMode = function (name) {
const editor = $(name).dxTextBox('instance');
editor.option('mode', editor.option('mode') === 'text' ? 'password' : 'text');
};
$('#summary').dxValidationSummary({ });
$('#email-validation').dxTextBox({
inputAttr: { 'aria-label': 'Email' },
})
.dxValidator({
validationRules: [{
type: 'required',
message: 'Email is required',
}, {
type: 'email',
message: 'Email is invalid',
}, {
type: 'async',
message: 'Email is already registered',
validationCallback(params) {
return sendRequest(params.value);
},
}],
});
$('#password-validation').dxTextBox({
mode: 'password',
inputAttr: { 'aria-label': 'Password' },
onValueChanged() {
const editor = $('#confirm-password-validation').dxTextBox('instance');
if (editor.option('value')) {
$('#confirm-password-validation').dxValidator('validate');
}
},
buttons: [{
name: 'password',
location: 'after',
options: {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => changePasswordMode('#password-validation'),
},
}],
}).dxValidator({
validationRules: [{
type: 'required',
message: 'Password is required',
}],
});
$('#confirm-password-validation').dxTextBox({
mode: 'password',
inputAttr: { 'aria-label': 'Password' },
buttons: [{
name: 'password',
location: 'after',
options: {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => changePasswordMode('#confirm-password-validation'),
},
}],
}).dxValidator({
validationRules: [{
type: 'compare',
comparisonTarget() {
const password = $('#password-validation').dxTextBox('instance');
if (password) {
return password.option('value');
}
return null;
},
message: "'Password' and 'Confirm Password' do not match.",
},
{
type: 'required',
message: 'Confirm Password is required',
}],
});
$('#name-validation').dxTextBox({
value: 'Peter',
inputAttr: { 'aria-label': 'Name' },
}).dxValidator({
validationRules: [{
type: 'required',
message: 'Name is required',
}, {
type: 'pattern',
pattern: /^[^0-9]+$/,
message: 'Do not use digits in the Name.',
}, {
type: 'stringLength',
min: 2,
message: 'Name must have at least 2 symbols',
}],
});
$('#date-validation').dxDateBox({
invalidDateMessage: 'The date must have the following format: MM/dd/yyyy',
inputAttr: { 'aria-label': 'Date' },
}).dxValidator({
validationRules: [{
type: 'required',
message: 'Date of birth is required',
}, {
type: 'range',
max: maxDate,
message: 'You must be at least 21 years old',
}],
});
$('#vacation-validation').dxDateRangeBox({
inputAttr: { 'aria-label': 'Vacation Dates' },
}).dxValidator({
validationRules: [{
type: 'custom',
validationCallback: ({ value }) => {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
},
message: 'The vacation period must not exceed 25 days',
}, {
type: 'custom',
validationCallback: ({ value }) => {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
},
message: 'Both start and end dates must be selected',
}],
});
$('#country-validation').dxSelectBox({
dataSource: countries,
inputAttr: { 'aria-label': 'Country' },
validationMessagePosition: 'left',
}).dxValidator({
validationRules: [{
type: 'required',
message: 'Country is required',
}],
});
$('#city-validation').dxTextBox({
validationMessagePosition: 'left',
inputAttr: { 'aria-label': 'City' },
})
.dxValidator({
validationRules: [{
type: 'required',
message: 'City is required',
}, {
type: 'pattern',
pattern: '^[^0-9]+$',
message: 'Do not use digits in the City name.',
}, {
type: 'stringLength',
min: 2,
message: 'City must have at least 2 symbols',
}],
});
$('#address-validation').dxTextBox({
validationMessagePosition: 'left',
inputAttr: { 'aria-label': 'Address' },
})
.dxValidator({
validationRules: [{
type: 'required',
message: 'Address is required',
}],
});
$('#phone-validation').dxTextBox({
mask: '(X00) 000-0000',
inputAttr: { 'aria-label': 'Phone' },
maskRules: {
X: /[02-9]/,
},
maskInvalidMessage: 'The phone must have a correct USA phone format',
validationMessagePosition: 'left',
}).dxValidator({
validationRules: [{
type: 'pattern',
pattern: /^[02-9]\d{9}$/,
message: 'The phone must have a correct USA phone format',
}],
});
$('#check').dxCheckBox({
value: false,
text: 'I agree to the Terms and Conditions',
validationMessagePosition: 'right',
}).dxValidator({
validationRules: [{
type: 'compare',
comparisonTarget() { return true; },
message: 'You must agree to the Terms and Conditions',
}],
});
$('#form').on('submit', (e) => {
DevExpress.ui.notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
});
$('#button').dxButton({
width: '120px',
text: 'Register',
type: 'default',
useSubmitBehavior: true,
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<form id="form" action="your-action">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Credentials</div>
<div class="dx-field">
<div class="dx-field-label">Email</div>
<div class="dx-field-value">
<div id="email-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Password</div>
<div class="dx-field-value">
<div id="password-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Confirm Password</div>
<div class="dx-field-value">
<div id="confirm-password-validation"></div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Personal Data</div>
<div class="dx-field">
<div class="dx-field-label">Name</div>
<div class="dx-field-value">
<div id="name-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Date of birth</div>
<div class="dx-field-value">
<div id="date-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Vacation Dates</div>
<div class="dx-field-value">
<div id="vacation-validation"></div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Billing address</div>
<div class="dx-field">
<div class="dx-field-label">Country</div>
<div class="dx-field-value">
<div id="country-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">City</div>
<div class="dx-field-value">
<div id="city-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Address</div>
<div class="dx-field-value">
<div id="address-validation"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Phone <i>(optional)</i></div>
<div class="dx-field-value">
<div id="phone-validation"></div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<div id="check"></div>
</div>
<div class="dx-field-value">
<div id="button"></div>
</div>
</div>
<div id="summary"></div>
</div>
</form>
</div>
</body>
</html>
#summary {
padding-left: 10px;
margin-top: 20px;
margin-bottom: 10px;
}
const countries = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];

<template>
<form
action="your-action"
@submit="onFormSubmit($event)"
>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Credentials</div>
<div class="dx-field">
<div class="dx-field-label">Email</div>
<div class="dx-field-value">
<DxTextBox :input-attr="{ 'aria-label': 'Email' }">
<DxValidator>
<DxRequiredRule message="Email is required"/>
<DxEmailRule message="Email is invalid"/>
<DxAsyncRule
:validation-callback="asyncValidation"
message="Email is already registered"
/>
</DxValidator>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Password</div>
<div class="dx-field-value">
<DxTextBox
v-model:value="password"
:input-attr="{ 'aria-label': 'Password' }"
v-model:mode="passwordMode"
@value-changed="onPasswordChanged"
>
<DxTextBoxButton
name="password"
location="after"
:options="passwordButton"
/>
<DxValidator>
<DxRequiredRule message="Password is required"/>
</DxValidator>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Confirm Password</div>
<div class="dx-field-value">
<DxTextBox
v-model:value="confirmPassword"
:input-attr="{ 'aria-label': 'Password' }"
v-model:mode="confirmPasswordMode"
>
<DxTextBoxButton
name="password"
location="after"
:options="confirmPasswordButton"
/>
<DxValidator @initialized="onInit">
<DxRequiredRule message="Confirm Password is required"/>
<DxCompareRule
:comparison-target="passwordComparison"
message="Password and Confirm Password do not match"
/>
</DxValidator>
</DxTextBox>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Personal Data</div>
<div class="dx-field">
<div class="dx-field-label">Name</div>
<div class="dx-field-value">
<DxTextBox
value="Peter"
:input-attr="{ 'aria-label': 'Name' }"
>
<DxValidator>
<DxRequiredRule message="Name is required"/>
<DxPatternRule
:pattern="namePattern"
message="Do not use digits in the Name"
/>
<DxStringLengthRule
:min="2"
message="Name must have at least 2 symbols"
/>
</DxValidator>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Date of birth</div>
<div class="dx-field-value">
<DxDateBox
invalid-date-message="The date must have the following format: MM/dd/yyyy"
:input-attr="{ 'aria-label': 'Date' }"
>
<DxValidator>
<DxRequiredRule message="Date of birth is required"/>
<DxRangeRule
:max="maxDate"
message="You must be at least 21 years old"
/>
</DxValidator>
</DxDateBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Vacation Dates</div>
<div class="dx-field-value">
<DxDateRangeBox
:input-attr="{ 'aria-label': 'Vacation' }"
>
<DxValidator>
<DxCustomRule
:validation-callback="validateVacationDatesRange"
message="The vacation period must not exceed 25 days"
/>
<DxCustomRule
:validation-callback="validateVacationDatesPresence"
message="Both start and end dates must be selected"
/>
</DxValidator>
</DxDateRangeBox>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Billing address</div>
<div class="dx-field">
<div class="dx-field-label">Country</div>
<div class="dx-field-value">
<DxSelectBox
:data-source="countries"
:input-attr="{ 'aria-label': 'Country' }"
validation-message-position="left"
>
<DxValidator>
<DxRequiredRule message="Country is required"/>
</DxValidator>
</DxSelectBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">City</div>
<div class="dx-field-value">
<DxTextBox
validation-message-position="left"
:input-attr="{ 'aria-label': 'City' }"
>
<DxValidator>
<DxRequiredRule message="City is required"/>
<DxPatternRule
:pattern="namePattern"
message="Do not use digits in the City name"
/>
<DxStringLengthRule
:min="2"
message="City must have at least 2 symbols"
/>
</DxValidator>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Address</div>
<div class="dx-field-value">
<DxTextBox
validation-message-position="left"
:input-attr="{ 'aria-label': 'Address' }"
>
<DxValidator>
<DxRequiredRule message="Address is required"/>
</DxValidator>
</DxTextBox>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Phone <i>(optional)</i></div>
<div class="dx-field-value">
<DxTextBox
:mask-rules="phoneRules"
:input-attr="{ 'aria-label': 'Mask' }"
mask="(X00) 000-0000"
mask-invalid-message="The phone must have a correct USA phone format"
validation-message-position="left"
>
<DxValidator>
<DxPatternRule
:pattern="phonePattern"
message="The phone must have a correct USA phone format"
/>
</DxValidator>
</DxTextBox>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<DxCheckBox
id="check"
:value="false"
text="I agree to the Terms and Conditions"
validation-message-position="right"
>
<DxValidator>
<DxCompareRule
:comparison-target="checkComparison"
message="You must agree to the Terms and Conditions"
/>
</DxValidator>
</DxCheckBox>
</div>
<div class="dx-field-value">
<DxButton
width="120px"
:use-submit-behavior="true"
text="Register"
type="default"
/>
</div>
</div>
<DxValidationSummary id="summary"/>
</div>
</form>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSelectBox from 'devextreme-vue/select-box';
import DxCheckBox from 'devextreme-vue/check-box';
import { DxTextBox, DxButton as DxTextBoxButton, type DxTextBoxTypes } from 'devextreme-vue/text-box';
import DxDateBox from 'devextreme-vue/date-box';
import DxDateRangeBox from 'devextreme-vue/date-range-box';
import DxButton from 'devextreme-vue/button';
import DxValidationSummary from 'devextreme-vue/validation-summary';
import {
DxValidator,
DxRequiredRule,
DxCompareRule,
DxEmailRule,
DxPatternRule,
DxStringLengthRule,
DxRangeRule,
DxAsyncRule,
DxCustomRule,
type DxValidatorTypes,
} from 'devextreme-vue/validator';
import notify from 'devextreme/ui/notify';
import service from './data.ts';
const currentDate = new Date();
const countries = ref(service.getCountries());
const phoneRules = ref({
X: /[02-9]/,
});
const password = ref('');
const confirmPassword = ref('');
const passwordMode = ref<DxTextBoxTypes.TextBoxType>('password');
const confirmPasswordMode = ref<DxTextBoxTypes.TextBoxType>('password');
const passwordButton = ref({
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
passwordMode.value = passwordMode.value === 'text' ? 'password' : 'text';
},
});
const confirmPasswordButton = ref({
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
confirmPasswordMode.value = confirmPasswordMode.value === 'text' ? 'password' : 'text';
},
});
const namePattern = ref(/^[^0-9]+$/);
const phonePattern = ref(/^[02-9]\d{9}$/);
const maxDate = ref(new Date(currentDate.setFullYear(currentDate.getFullYear() - 21)));
let validatorInstance: DxValidator['instance'];
function passwordComparison() {
return password.value;
}
function checkComparison() {
return true;
}
function asyncValidation(params: Record<string, any>) {
return sendRequest(params.value);
}
function validateVacationDatesRange({ value }: Record<string, any>) {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
}
function validateVacationDatesPresence({ value }: Record<string, any>) {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
}
function onPasswordChanged() {
if (confirmPassword.value) {
validatorInstance?.validate();
}
}
function onInit(e: DxValidatorTypes.InitializedEvent) {
validatorInstance = e.component;
}
function onFormSubmit(e: Event) {
notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
}
function sendRequest(value: string) {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve) => {
setTimeout(() => {
resolve(value !== invalidEmail);
}, 1000);
});
}
</script>
<style scoped>
#summary {
padding-left: 10px;
margin-top: 20px;
margin-bottom: 10px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
const countries: string[] = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
export default {
getCountries() {
return countries;
},
};
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<form action="your-action" (submit)="onFormSubmit($event)">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Credentials</div>
<div class="dx-field">
<div class="dx-field-label">Email</div>
<div class="dx-field-value">
<dx-text-box [inputAttr]="{ 'aria-label': 'Email' }">
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Email is required"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="email"
message="Email is invalid"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="async"
message="Email is already registered"
[validationCallback]="asyncValidation"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Password</div>
<div class="dx-field-value">
<dx-text-box
[inputAttr]="{ 'aria-label': 'Password' }"
[mode]="passwordMode"
[(value)]="password"
(onValueChanged)="onPasswordChanged()"
>
<dxi-text-box-button
name="password"
location="after"
[options]="passwordButton"
></dxi-text-box-button>
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Password is required"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Confirm Password</div>
<div class="dx-field-value">
<dx-text-box
[(value)]="confirmPassword"
[mode]="confirmPasswordMode"
[inputAttr]="{ 'aria-label': 'Password' }"
>
<dxi-text-box-button
name="password"
location="after"
[options]="confirmPasswordButton"
></dxi-text-box-button>
<dx-validator #targetValidator>
<dxi-validator-validation-rule
type="required"
message="Confirm Password is required"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="compare"
[comparisonTarget]="passwordComparison"
message="Password and Confirm Password do not match"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Personal Data</div>
<div class="dx-field">
<div class="dx-field-label">Name</div>
<div class="dx-field-value">
<dx-text-box value="Peter" [inputAttr]="{ 'aria-label': 'Name' }">
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Name is required"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="pattern"
[pattern]="namePattern"
message="Do not use digits in the Name"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="stringLength"
[min]="2"
message="Name must have at least 2 symbols"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Date of birth</div>
<div class="dx-field-value">
<dx-date-box
invalidDateMessage="The date must have the following format: MM/dd/yyyy"
[inputAttr]="{ 'aria-label': 'Date Of Birth' }"
>
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Date of birth is required"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="range"
[max]="maxDate"
message="You must be at least 21 years old"
></dxi-validator-validation-rule>
</dx-validator>
</dx-date-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Vacation Dates</div>
<div class="dx-field-value">
<dx-date-range-box>
<dx-validator>
<dxi-validator-validation-rule
type="custom"
message="The vacation period must not exceed 25 days"
[validationCallback]="validateVacationDatesRange"
>
</dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="custom"
message="Both start and end dates must be selected"
[validationCallback]="validateVacationDatesPresence"
>
</dxi-validator-validation-rule>
</dx-validator>
</dx-date-range-box>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Billing address</div>
<div class="dx-field">
<div class="dx-field-label">Country</div>
<div class="dx-field-value">
<dx-select-box
[dataSource]="countries"
[inputAttr]="{ 'aria-label': 'Country' }"
validationMessagePosition="left"
>
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Country is required"
></dxi-validator-validation-rule>
</dx-validator>
</dx-select-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">City</div>
<div class="dx-field-value">
<dx-text-box
validationMessagePosition="left"
[inputAttr]="{ 'aria-label': 'City' }"
>
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="City is required"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="pattern"
[pattern]="cityPattern"
message="Do not use digits in the City name"
></dxi-validator-validation-rule>
<dxi-validator-validation-rule
type="stringLength"
[min]="2"
message="City must have at least 2 symbols"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Address</div>
<div class="dx-field-value">
<dx-text-box
validationMessagePosition="left"
[inputAttr]="{ 'aria-label': 'Address' }"
>
<dx-validator>
<dxi-validator-validation-rule
type="required"
message="Address is required"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">Phone <i>(optional)</i></div>
<div class="dx-field-value">
<dx-text-box
[inputAttr]="{ 'aria-label': 'Phone' }"
mask="(X00) 000-0000"
[maskRules]="phoneRules"
maskInvalidMessage="The phone must have a correct USA phone format"
validationMessagePosition="left"
>
<dx-validator>
<dxi-validator-validation-rule
type="pattern"
[pattern]="phonePattern"
message="The phone must have a correct USA phone format"
></dxi-validator-validation-rule>
</dx-validator>
</dx-text-box>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<dx-check-box
id="check"
[value]="false"
text="I agree to the Terms and Conditions"
validationMessagePosition="right"
>
<dx-validator>
<dxi-validator-validation-rule
type="compare"
[comparisonTarget]="checkComparison"
message="You must agree to the Terms and Conditions"
></dxi-validator-validation-rule>
</dx-validator>
</dx-check-box>
</div>
<div class="dx-field-value">
<dx-button
width="120px"
id="button"
text="Register"
type="default"
[useSubmitBehavior]="true"
>
</dx-button>
<dx-validation-summary id="summary"></dx-validation-summary>
</div>
</div>
</div>
</form>
import {
Component, enableProdMode, ViewChild, provideZoneChangeDetection,
} from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import {
DxSelectBoxModule,
DxCheckBoxModule,
DxTextBoxModule,
DxDateBoxModule,
DxDateRangeBoxModule,
DxButtonModule,
DxValidatorModule,
DxValidatorComponent,
DxValidationSummaryModule,
} from 'devextreme-angular';
import notify from 'devextreme/ui/notify';
import { DxButtonTypes } from 'devextreme-angular/ui/button';
import { DxTextBoxTypes } from 'devextreme-angular/ui/text-box';
import { ValidationCallbackData } from 'devextreme-angular/common';
import { Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
const sendRequest = function (value: string) {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve) => {
setTimeout(() => {
resolve(value !== invalidEmail);
}, 1000);
});
};
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxSelectBoxModule,
DxCheckBoxModule,
DxTextBoxModule,
DxDateBoxModule,
DxDateRangeBoxModule,
DxButtonModule,
DxValidatorModule,
DxValidationSummaryModule,
],
})
export class AppComponent {
@ViewChild('targetValidator', { static: false }) validator: DxValidatorComponent;
password = '';
confirmPassword = '';
passwordMode: DxTextBoxTypes.TextBoxType = 'password';
confirmPasswordMode: DxTextBoxTypes.TextBoxType = 'password';
maxDate = new Date();
cityPattern = '^[^0-9]+$';
namePattern = /^[^0-9]+$/;
phonePattern = /^[02-9]\d{9}$/;
countries: string[];
phoneRules: DxTextBoxTypes.Properties['maskRules'] = {
X: /[02-9]/,
};
passwordButton: DxButtonTypes.Properties = {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
this.passwordMode = this.passwordMode === 'text' ? 'password' : 'text';
},
};
confirmPasswordButton: DxButtonTypes.Properties = {
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
this.confirmPasswordMode = this.confirmPasswordMode === 'text' ? 'password' : 'text';
},
};
constructor(service: Service) {
this.maxDate = new Date(this.maxDate.setFullYear(this.maxDate.getFullYear() - 21));
this.countries = service.getCountries();
}
passwordComparison = () => this.password;
checkComparison = () => true;
validateVacationDatesRange({ value: [startDate, endDate] }: ValidationCallbackData) {
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
}
validateVacationDatesPresence({ value: [startDate, endDate] }: ValidationCallbackData) {
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
}
asyncValidation = (params: ValidationCallbackData) => sendRequest(params.value);
onPasswordChanged() {
if (this.confirmPassword) {
this.validator.instance.validate();
}
}
onFormSubmit = function (e: SubmitEvent) {
notify({
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
}, 'success', 3000);
e.preventDefault();
};
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #summary {
padding-left: 10px;
margin-top: 20px;
margin-bottom: 10px;
}
import { Injectable } from '@angular/core';
const countries: string[] = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
@Injectable()
export class Service {
getCountries() {
return countries;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React, {
useCallback,
useMemo,
useRef,
useState,
} from 'react';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import { TextBox, Button as TextBoxButton } from 'devextreme-react/text-box';
import type { TextBoxTypes } from 'devextreme-react/text-box';
import DateBox from 'devextreme-react/date-box';
import DateRangeBox from 'devextreme-react/date-range-box';
import Button from 'devextreme-react/button';
import type { ButtonTypes } from 'devextreme-react/button';
import type { ValidationCallbackData } from 'devextreme/common';
import ValidationSummary from 'devextreme-react/validation-summary';
import {
Validator,
RequiredRule,
CompareRule,
EmailRule,
PatternRule,
StringLengthRule,
RangeRule,
AsyncRule,
CustomRule,
} from 'devextreme-react/validator';
import type { ValidatorRef } from 'devextreme-react/validator';
import notify from 'devextreme/ui/notify';
import {
countries,
nameLabel,
passwordLabel,
emailLabel,
maskLabel,
dateLabel,
cityLabel,
addressLabel,
countryLabel,
} from './data.ts';
const cityPattern = '^[^0-9]+$';
const namePattern = /^[^0-9]+$/;
const phonePattern = /^[02-9]\d{9}$/;
const phoneRules = {
X: /[02-9]/,
};
const checkComparison = (): boolean => true;
const onFormSubmit = (e: { preventDefault: () => void }): void => {
notify(
{
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
e.preventDefault();
};
function App() {
const currentDate = new Date();
const maxDate = new Date(currentDate.setFullYear(currentDate.getFullYear() - 21));
const [password, setPassword] = useState<string>('');
const [confirmPassword, setConfirmPassword] = useState<string>('');
const [passwordMode, setPasswordMode] = useState<TextBoxTypes.TextBoxType>('password');
const [confirmPasswordMode, setConfirmPasswordMode] = useState<TextBoxTypes.TextBoxType>('password');
const validatorRef = useRef<ValidatorRef>(null);
const passwordButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: (): void => {
setPasswordMode(passwordMode === 'text' ? 'password' : 'text');
},
}),
[passwordMode],
);
const confirmPasswordButton = useMemo<ButtonTypes.Properties>(
(): ButtonTypes.Properties => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: (): void => {
setConfirmPasswordMode(confirmPasswordMode === 'text' ? 'password' : 'text');
},
}),
[confirmPasswordMode],
);
const passwordComparison = useCallback((): string => password, [password]);
const onPasswordChanged = useCallback(
(e: TextBoxTypes.ValueChangedEvent): void => {
setPassword(e.value);
if (confirmPassword) {
validatorRef.current?.instance().validate();
}
},
[confirmPassword],
);
const onConfirmPasswordChanged = useCallback((e: TextBoxTypes.ValueChangedEvent): void => {
setConfirmPassword(e.value);
}, []);
return (
<form
action="your-action"
onSubmit={onFormSubmit}
>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Credentials</div>
<div className="dx-field">
<div className="dx-field-label">Email</div>
<div className="dx-field-value">
<TextBox inputAttr={emailLabel}>
<Validator>
<RequiredRule message="Email is required" />
<EmailRule message="Email is invalid" />
<AsyncRule
message="Email is already registered"
validationCallback={asyncValidation}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Password</div>
<div className="dx-field-value">
<TextBox
mode={passwordMode}
value={password}
inputAttr={passwordLabel}
onValueChanged={onPasswordChanged}
>
<TextBoxButton
name="password"
location="after"
options={passwordButton}
/>
<Validator>
<RequiredRule message="Password is required" />
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Confirm Password</div>
<div className="dx-field-value">
<TextBox
value={confirmPassword}
inputAttr={passwordLabel}
onValueChanged={onConfirmPasswordChanged}
mode={confirmPasswordMode}
>
<TextBoxButton
name="password"
location="after"
options={confirmPasswordButton}
/>
<Validator ref={validatorRef}>
<RequiredRule message="Confirm Password is required" />
<CompareRule
message="Password and Confirm Password do not match"
comparisonTarget={passwordComparison}
/>
</Validator>
</TextBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Personal Data</div>
<div className="dx-field">
<div className="dx-field-label">Name</div>
<div className="dx-field-value">
<TextBox
value="Peter"
inputAttr={nameLabel}
>
<Validator>
<RequiredRule message="Name is required" />
<PatternRule
message="Do not use digits in the Name"
pattern={namePattern}
/>
<StringLengthRule
message="Name must have at least 2 symbols"
min={2}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Date of birth</div>
<div className="dx-field-value">
<DateBox
invalidDateMessage="The date must have the following format: MM/dd/yyyy"
inputAttr={dateLabel}
>
<Validator>
<RequiredRule message="Date of birth is required" />
<RangeRule
message="You must be at least 21 years old"
max={maxDate}
/>
</Validator>
</DateBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Vacation Dates</div>
<div className="dx-field-value">
<DateRangeBox>
<Validator>
<CustomRule message="The vacation period must not exceed 25 days" validationCallback={validateVacationDatesRange} />
<CustomRule message="Both start and end dates must be selected" validationCallback={validateVacationDatesPresence} />
</Validator>
</DateRangeBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Billing address</div>
<div className="dx-field">
<div className="dx-field-label">Country</div>
<div className="dx-field-value">
<SelectBox
dataSource={countries}
validationMessagePosition="left"
inputAttr={countryLabel}
>
<Validator>
<RequiredRule message="Country is required" />
</Validator>
</SelectBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">City</div>
<div className="dx-field-value">
<TextBox
validationMessagePosition="left"
inputAttr={cityLabel}
>
<Validator>
<RequiredRule message="City is required" />
<PatternRule
message="Do not use digits in the City name"
pattern={cityPattern}
/>
<StringLengthRule
message="City must have at least 2 symbols"
min={2}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Address</div>
<div className="dx-field-value">
<TextBox
validationMessagePosition="left"
inputAttr={addressLabel}
>
<Validator>
<RequiredRule message="Address is required" />
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">
Phone <i>(optional)</i>
</div>
<div className="dx-field-value">
<TextBox
mask="(X00) 000-0000"
inputAttr={maskLabel}
maskRules={phoneRules}
maskInvalidMessage="The phone must have a correct USA phone format"
validationMessagePosition="left"
>
<Validator>
<PatternRule
message="The phone must have a correct USA phone format"
pattern={phonePattern}
/>
</Validator>
</TextBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">
<CheckBox
id="check"
defaultValue={false}
text="I agree to the Terms and Conditions"
validationMessagePosition="right"
>
<Validator>
<CompareRule
message="You must agree to the Terms and Conditions"
comparisonTarget={checkComparison}
/>
</Validator>
</CheckBox>
</div>
<div className="dx-field-value">
<Button
width="120px"
id="button"
text="Register"
type="default"
useSubmitBehavior={true}
/>
</div>
</div>
<ValidationSummary id="summary" />
</div>
</form>
);
}
function sendRequest(value: string): Promise<boolean> {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve): void => {
setTimeout((): void => {
resolve(value !== invalidEmail);
}, 1000);
});
}
function asyncValidation(params: ValidationCallbackData): Promise<boolean> {
return sendRequest(params.value);
}
function validateVacationDatesRange({ value }: ValidationCallbackData): boolean {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
}
function validateVacationDatesPresence({ value }: ValidationCallbackData): boolean {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
}
export default App;
import React, {
useCallback, useMemo, useRef, useState,
} from 'react';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import { TextBox, Button as TextBoxButton } from 'devextreme-react/text-box';
import DateBox from 'devextreme-react/date-box';
import DateRangeBox from 'devextreme-react/date-range-box';
import Button from 'devextreme-react/button';
import ValidationSummary from 'devextreme-react/validation-summary';
import {
Validator,
RequiredRule,
CompareRule,
EmailRule,
PatternRule,
StringLengthRule,
RangeRule,
AsyncRule,
CustomRule,
} from 'devextreme-react/validator';
import notify from 'devextreme/ui/notify';
import {
countries,
nameLabel,
passwordLabel,
emailLabel,
maskLabel,
dateLabel,
cityLabel,
addressLabel,
countryLabel,
} from './data.js';
const cityPattern = '^[^0-9]+$';
const namePattern = /^[^0-9]+$/;
const phonePattern = /^[02-9]\d{9}$/;
const phoneRules = {
X: /[02-9]/,
};
const checkComparison = () => true;
const onFormSubmit = (e) => {
notify(
{
message: 'You have submitted the form',
position: {
my: 'center top',
at: 'center top',
},
},
'success',
3000,
);
e.preventDefault();
};
function App() {
const currentDate = new Date();
const maxDate = new Date(currentDate.setFullYear(currentDate.getFullYear() - 21));
const [password, setPassword] = useState('');
const [confirmPassword, setConfirmPassword] = useState('');
const [passwordMode, setPasswordMode] = useState('password');
const [confirmPasswordMode, setConfirmPasswordMode] = useState('password');
const validatorRef = useRef(null);
const passwordButton = useMemo(
() => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
setPasswordMode(passwordMode === 'text' ? 'password' : 'text');
},
}),
[passwordMode],
);
const confirmPasswordButton = useMemo(
() => ({
icon: 'eyeopen',
stylingMode: 'text',
onClick: () => {
setConfirmPasswordMode(confirmPasswordMode === 'text' ? 'password' : 'text');
},
}),
[confirmPasswordMode],
);
const passwordComparison = useCallback(() => password, [password]);
const onPasswordChanged = useCallback(
(e) => {
setPassword(e.value);
if (confirmPassword) {
validatorRef.current?.instance().validate();
}
},
[confirmPassword],
);
const onConfirmPasswordChanged = useCallback((e) => {
setConfirmPassword(e.value);
}, []);
return (
<form
action="your-action"
onSubmit={onFormSubmit}
>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Credentials</div>
<div className="dx-field">
<div className="dx-field-label">Email</div>
<div className="dx-field-value">
<TextBox inputAttr={emailLabel}>
<Validator>
<RequiredRule message="Email is required" />
<EmailRule message="Email is invalid" />
<AsyncRule
message="Email is already registered"
validationCallback={asyncValidation}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Password</div>
<div className="dx-field-value">
<TextBox
mode={passwordMode}
value={password}
inputAttr={passwordLabel}
onValueChanged={onPasswordChanged}
>
<TextBoxButton
name="password"
location="after"
options={passwordButton}
/>
<Validator>
<RequiredRule message="Password is required" />
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Confirm Password</div>
<div className="dx-field-value">
<TextBox
value={confirmPassword}
inputAttr={passwordLabel}
onValueChanged={onConfirmPasswordChanged}
mode={confirmPasswordMode}
>
<TextBoxButton
name="password"
location="after"
options={confirmPasswordButton}
/>
<Validator ref={validatorRef}>
<RequiredRule message="Confirm Password is required" />
<CompareRule
message="Password and Confirm Password do not match"
comparisonTarget={passwordComparison}
/>
</Validator>
</TextBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Personal Data</div>
<div className="dx-field">
<div className="dx-field-label">Name</div>
<div className="dx-field-value">
<TextBox
value="Peter"
inputAttr={nameLabel}
>
<Validator>
<RequiredRule message="Name is required" />
<PatternRule
message="Do not use digits in the Name"
pattern={namePattern}
/>
<StringLengthRule
message="Name must have at least 2 symbols"
min={2}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Date of birth</div>
<div className="dx-field-value">
<DateBox
invalidDateMessage="The date must have the following format: MM/dd/yyyy"
inputAttr={dateLabel}
>
<Validator>
<RequiredRule message="Date of birth is required" />
<RangeRule
message="You must be at least 21 years old"
max={maxDate}
/>
</Validator>
</DateBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Vacation Dates</div>
<div className="dx-field-value">
<DateRangeBox>
<Validator>
<CustomRule
message="The vacation period must not exceed 25 days"
validationCallback={validateVacationDatesRange}
/>
<CustomRule
message="Both start and end dates must be selected"
validationCallback={validateVacationDatesPresence}
/>
</Validator>
</DateRangeBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Billing address</div>
<div className="dx-field">
<div className="dx-field-label">Country</div>
<div className="dx-field-value">
<SelectBox
dataSource={countries}
validationMessagePosition="left"
inputAttr={countryLabel}
>
<Validator>
<RequiredRule message="Country is required" />
</Validator>
</SelectBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">City</div>
<div className="dx-field-value">
<TextBox
validationMessagePosition="left"
inputAttr={cityLabel}
>
<Validator>
<RequiredRule message="City is required" />
<PatternRule
message="Do not use digits in the City name"
pattern={cityPattern}
/>
<StringLengthRule
message="City must have at least 2 symbols"
min={2}
/>
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">Address</div>
<div className="dx-field-value">
<TextBox
validationMessagePosition="left"
inputAttr={addressLabel}
>
<Validator>
<RequiredRule message="Address is required" />
</Validator>
</TextBox>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">
Phone <i>(optional)</i>
</div>
<div className="dx-field-value">
<TextBox
mask="(X00) 000-0000"
inputAttr={maskLabel}
maskRules={phoneRules}
maskInvalidMessage="The phone must have a correct USA phone format"
validationMessagePosition="left"
>
<Validator>
<PatternRule
message="The phone must have a correct USA phone format"
pattern={phonePattern}
/>
</Validator>
</TextBox>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">
<CheckBox
id="check"
defaultValue={false}
text="I agree to the Terms and Conditions"
validationMessagePosition="right"
>
<Validator>
<CompareRule
message="You must agree to the Terms and Conditions"
comparisonTarget={checkComparison}
/>
</Validator>
</CheckBox>
</div>
<div className="dx-field-value">
<Button
width="120px"
id="button"
text="Register"
type="default"
useSubmitBehavior={true}
/>
</div>
</div>
<ValidationSummary id="summary" />
</div>
</form>
);
}
function sendRequest(value) {
const invalidEmail = 'test@dx-email.com';
return new Promise((resolve) => {
setTimeout(() => {
resolve(value !== invalidEmail);
}, 1000);
});
}
function asyncValidation(params) {
return sendRequest(params.value);
}
function validateVacationDatesRange({ value }) {
const [startDate, endDate] = value;
if (startDate === null || endDate === null) {
return true;
}
const millisecondsPerDay = 24 * 60 * 60 * 1000;
const daysDifference = Math.abs((endDate - startDate) / millisecondsPerDay);
return daysDifference < 25;
}
function validateVacationDatesPresence({ value }) {
const [startDate, endDate] = value;
if (startDate === null && endDate === null) {
return true;
}
return startDate !== null && endDate !== null;
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(<App />, document.getElementById('app'));
export const countries: string[] = ['Afghanistan', 'Albania', 'Algeria', 'Andorra', 'Angola', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Australia', 'Austria', 'Azerbaijan', 'The Bahamas', 'Bahrain', 'Bangladesh', 'Barbados', 'Belgium', 'Belize', 'Benin', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'Brunei', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Central African Republic', 'Chad', 'Chile', 'Colombia', 'Comoros', 'Democratic Republic of the Congo', 'Republic of the Congo', 'Costa Rica', 'Ivory Coast', 'Croatia', 'Cuba', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'Egypt', 'El Salvador', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Fiji', 'Finland', 'France', 'Gabon', 'The Gambia', 'Georgia', 'Germany', 'Ghana', 'Greece', 'Grenada', 'Guatemala', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Honduras', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Republic of Ireland', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'North Korea', 'South Korea', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Republic of Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Mauritania', 'Mauritius', 'Mexico', 'Federated States of Micronesia', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Kingdom of the Netherlands', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Norway', 'Oman', 'Pakistan', 'Palau', 'State of Palestine', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Poland', 'Portugal', 'Qatar', 'Romania', 'Rwanda', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Vincent and the Grenadines', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Sudan', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Swaziland', 'Sweden', 'Switzerland', 'Syria', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Venezuela', 'Vietnam', 'Yemen', 'Zambia', 'Zimbabwe'];
export const nameLabel = { 'aria-label': 'Name' };
export const emailLabel = { 'aria-label': 'Email' };
export const maskLabel = { 'aria-label': 'Mask' };
export const dateLabel = { 'aria-label': 'Date' };
export const cityLabel = { 'aria-label': 'City' };
export const addressLabel = { 'aria-label': 'Address' };
export const passwordLabel = { 'aria-label': 'Password' };
export const countryLabel = { 'aria-label': 'Country' };
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const countries = [
'Afghanistan',
'Albania',
'Algeria',
'Andorra',
'Angola',
'Antigua and Barbuda',
'Argentina',
'Armenia',
'Australia',
'Austria',
'Azerbaijan',
'The Bahamas',
'Bahrain',
'Bangladesh',
'Barbados',
'Belgium',
'Belize',
'Benin',
'Bhutan',
'Bolivia',
'Bosnia and Herzegovina',
'Botswana',
'Brazil',
'Brunei',
'Bulgaria',
'Burkina Faso',
'Burma',
'Burundi',
'Cambodia',
'Cameroon',
'Canada',
'Cape Verde',
'Central African Republic',
'Chad',
'Chile',
'Colombia',
'Comoros',
'Democratic Republic of the Congo',
'Republic of the Congo',
'Costa Rica',
'Ivory Coast',
'Croatia',
'Cuba',
'Cyprus',
'Czech Republic',
'Denmark',
'Djibouti',
'Dominica',
'Dominican Republic',
'East Timor',
'Ecuador',
'Egypt',
'El Salvador',
'Equatorial Guinea',
'Eritrea',
'Estonia',
'Ethiopia',
'Fiji',
'Finland',
'France',
'Gabon',
'The Gambia',
'Georgia',
'Germany',
'Ghana',
'Greece',
'Grenada',
'Guatemala',
'Guinea',
'Guinea-Bissau',
'Guyana',
'Haiti',
'Honduras',
'Hungary',
'Iceland',
'India',
'Indonesia',
'Iraq',
'Republic of Ireland',
'Israel',
'Italy',
'Jamaica',
'Japan',
'Jordan',
'Kazakhstan',
'Kenya',
'Kiribati',
'North Korea',
'South Korea',
'Kuwait',
'Kyrgyzstan',
'Laos',
'Latvia',
'Lebanon',
'Lesotho',
'Liberia',
'Libya',
'Liechtenstein',
'Lithuania',
'Luxembourg',
'Republic of Macedonia',
'Madagascar',
'Malawi',
'Malaysia',
'Maldives',
'Mali',
'Malta',
'Marshall Islands',
'Mauritania',
'Mauritius',
'Mexico',
'Federated States of Micronesia',
'Moldova',
'Monaco',
'Mongolia',
'Montenegro',
'Morocco',
'Mozambique',
'Namibia',
'Nauru',
'Nepal',
'Kingdom of the Netherlands',
'New Zealand',
'Nicaragua',
'Niger',
'Nigeria',
'Norway',
'Oman',
'Pakistan',
'Palau',
'State of Palestine',
'Panama',
'Papua New Guinea',
'Paraguay',
'Peru',
'Philippines',
'Poland',
'Portugal',
'Qatar',
'Romania',
'Rwanda',
'Saint Kitts and Nevis',
'Saint Lucia',
'Saint Vincent and the Grenadines',
'Samoa',
'San Marino',
'São Tomé and Príncipe',
'Saudi Arabia',
'Senegal',
'Serbia',
'Seychelles',
'Sierra Leone',
'Singapore',
'Slovakia',
'Slovenia',
'Solomon Islands',
'Somalia',
'South Africa',
'South Sudan',
'Spain',
'Sri Lanka',
'Sudan',
'Suriname',
'Swaziland',
'Sweden',
'Switzerland',
'Syria',
'Tajikistan',
'Tanzania',
'Thailand',
'Togo',
'Tonga',
'Trinidad and Tobago',
'Tunisia',
'Turkey',
'Turkmenistan',
'Tuvalu',
'Uganda',
'Ukraine',
'United Arab Emirates',
'United Kingdom',
'United States',
'Uruguay',
'Uzbekistan',
'Vanuatu',
'Vatican City',
'Venezuela',
'Vietnam',
'Yemen',
'Zambia',
'Zimbabwe',
];
export const nameLabel = { 'aria-label': 'Name' };
export const emailLabel = { 'aria-label': 'Email' };
export const maskLabel = { 'aria-label': 'Mask' };
export const dateLabel = { 'aria-label': 'Date' };
export const cityLabel = { 'aria-label': 'City' };
export const addressLabel = { 'aria-label': 'Address' };
export const passwordLabel = { 'aria-label': 'Password' };
export const countryLabel = { 'aria-label': 'Country' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#summary {
padding-left: 10px;
margin-top: 20px;
margin-bottom: 10px;
}